genGridPT <- function(nX, nY, na, nb, Sx, Sy, ngrid, lambdarange = NULL, lambda2range = NULL){
p <- dim(nX)[2]
q <- dim(nY)[2]
Astar <- rbind(diag(1, nrow=p), t(Sx))
bstar <- rbind(t(nX)%*%nY%*%nb, matrix(0, p, 1))
tmp.a <- glmnet::glmnet(x=Astar, y=bstar, intercept=FALSE, alpha=1)

Bstar <- rbind(diag(1, nrow=q), t(Sy))
astar <- rbind(t(nY)%*%nX%*%na, matrix(0, q, 1))
tmp.b <- glmnet::glmnet(x=Bstar, y=astar, intercept=FALSE, alpha=1)
if (is.null(lambdarange)){
l1 <- seq(min(tmp.a$lambda),max(tmp.a$lambda), length=ngrid[1])
l3 <- seq(min(tmp.b$lambda),max(tmp.b$lambda), length=ngrid[3])
  if(is.null(lambda2range)){
    l2 <- l4 <- c(0.1, 0.5, 1)
  }else{
    l2 <- seq(lambda2range[1],lambda2range[2], length=ngrid[2])
    l4 <- seq(lambda2range[1],lambda2range[2], length=ngrid[4])
  }
}else{
l1 <- seq(lambdarange[1],lambdarange[2], length=ngrid[1])
l3 <- seq(lambdarange[3],lambdarange[4], length=ngrid[3])
  if(is.null(lambda2range)){
    l2 <- l4 <- c(0.1, 0.5, 1)
  }else{
    l2 <- seq(lambda2range[1],lambda2range[2], length=ngrid[2])
    l4 <- seq(lambda2range[3],lambda2range[4], length=ngrid[4])
  }
}
tmp <- cbind(rep(l3,each=length(l4)), rep(l4, length(l3)))
tmp2 <- cbind(rep(l2,each=(length(l3)*length(l4))), kronecker(matrix(1,length(l2),1), tmp))
gridpt <- cbind(rep(l1, each=(length(l2)*length(l3)*length(l4))), kronecker(matrix(1,length(l1),1), tmp2))
return(gridpt)
}
