scatterutil.eti = function (x, y, label, clabel, boxes = FALSE, coul = rep(1, length(x)),
   horizontal = TRUE, bg = "white")
{
   if (length(label) == 0)
       return(invisible())
   if (is.null(label))
       return(invisible())
   if (any(label == ""))
       return(invisible())
   cex0 <- par("cex") * clabel
   for (i in 1:(length(x))) {
       cha <- as.character(label[i])
       cha <- paste(" ", cha, " ", sep = "")
       x1 <- x[i]
       y1 <- y[i]
       xh <- strwidth(cha, cex = cex0)
       yh <- strheight(cha, cex = cex0) * 5/3
       if (!horizontal) {
           tmp <- scatterutil.convrot90(xh, yh)
           xh <- tmp[1]
           yh <- tmp[2]
       }
       if (boxes) {
           rect(x1 - xh/2, y1 - yh/2, x1 + xh/2, y1 + yh/2,
               col = bg, border = coul[i])
       }
       if (horizontal) {
           text(x1, y1, cha, cex = cex0, col = coul[i])
       }
       else {
           text(x1, y1, cha, cex = cex0, col = coul[i], srt = 90)
       }
   }
}
