\docType{data}
\name{NCI60path}
\alias{NCI60path}
\title{Patheway information data of NCI60 data for Penalized Co-Inertia Analysis (CIA)}
\usage{
  data(NCI60path)
}
\description{
  Extracted edge information for NCI60 data contained in the package \code{made4} from KEGG pathway database.
  Two columms stands for the vertices of all edges of existing graph in the data NCI60 dataset. 
}
\examples{
  data(NCI60path)
}
\references{
  Kanehisa, Furumichi, M., Tanabe, M., Sato, Y., and Morishima, K.; KEGG: new perspectives on genomes, pathways, diseases and drugs. Nucleic Acids Res. 45, D353-D361 (2017)
  
  AC C, J T, G P and DG H (2005). “MADE4:an R package for multivariate analysis of gene expression data.” Bioinformatics, 21(11), pp. 2789-90.
}
