plotgenes = function (coord, nlab = 10, axis1 = 1, axis2 = 2, genelabels = row.names(coord),
     boxes = FALSE, ...) #,
{
    if (!inherits(coord, "data.frame")) {
        if (inherits(coord, "bga")) {
            coord = coord$bet$co
        }
        if (inherits(coord, "between"))
            coord = coord$li
        if (inherits(coord, "ord")) {
            coord = coord$ord$li
        }
        if (inherits(coord, "dudi"))
            coord = coord$li
    }
    if (!inherits(labels, "character"))
        genelabels <- as.vector(genelabels)
    genelabels[genelabels == ""] <- "-"
    specInd <- made4:::genes(coord, nlab, axis1, axis2)
    specLab <- genelabels[specInd]
    specMat <- coord[specInd, ]
    made4:::s.var(coord, xax = axis1, yax = axis2, clabel = 0, colpoints = rep("black",
        nrow(coord)), ...)
    made4:::s.var(specMat, xax = axis1, yax = axis2, label = specLab,
      , colpoints = rep("red", nrow(coord)),
        boxes = boxes, cpoint = 0, add.plot = TRUE, ...)
}
